#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t, n, k;
    cin >> t >> n >> k;
    if (t != 0) exit(0);
    int a[n+1];
    for (int i = 1; i <= n; ++i)    cin >> a[i];
    int mx = 0, mn = 0;
    sort(a+1, a+n+1);
    for (int i = 1; i <= n; ++i) {
        if (mx <= a[i])
            mx++;
        else
            mx--;
    }
    for (int i = n; i >= 1; --i) {
        if (mn <= a[i])
            mn++;
        else
            mn--;
    }
    if (mn > k || mx < k || max(n,-n)%2 != max(k,-k)%2) {
        cout << "NE\n";
        return 0;
    }
    cout << "DA\n";
    exit(0);
    ll l = 0, r = n*(n-1)/2;
    while (l <= r) {
        ll m = (l+r)/2;
        int b[n+1];
        for (int i = 1; i <= n; ++i)    b[i] = a[n+1-i];
        int p = 0;
        ll d = m;
        for (int i = n; i >= 1; --i) {
            if (d > i-1) {
                if (p <= a[i])
                    p++;
                else
                    p--;
                d -= i-1;
            }
            else {
                for (int j = 1; j < i-d; ++j) {
                    if (p <= a[j])
                        p++;
                    else
                        p--;
                }
                if (p <= a[i])
                    p++;
                else
                    p--;
                for (int j = i-d; j < i; ++j) {
                    if (p <= a[j])
                        p++;
                    else
                        p--;
                }
            }
        }
        if (p == k) {
            for (int i = n; i >= 1; --i) {
                if (d > i-1) {
                    cout << i << ' ';
                    d -= i-1;
                }
                else {
                    for (int j = 1; j < i-d; ++j)   cout << j << ' ';
                    cout << i-d << ' ';
                    for (int j = i-d; j < i; ++j)   cout << j << ' ';
                }
            }
            cout << '\n';
            return 0;
        }
        if (p < k)
            l = m+1;
        else
            r = m-1;
    }
    return 0;
}